#include "tools.h"

typedef struct{
	t_dude* dude;
	t_coord dst;
	int ok;
} t_move;

t_move* clearMoves[MAX_DUDES*NB_TEAMS];
int nb_clear = 0;
t_move* occupiedMoves[MAX_DUDES*NB_TEAMS];
int nb_occupied = 0;
t_pixel** map;

void add_move(t_dude* dude, t_coord dst, t_pixel** the_map){
	map = the_map;
	t_move* move = malloc(sizeof(t_move));
	move->dude = dude;
	move->dst = dst;
	move->ok = 0;
	if(map[dst.x][dst.y].type == DUDE)
		occupiedMoves[nb_occupied++] = move;
	else
		clearMoves[nb_clear++] = move;
}

void applyMove(t_move* move){
	t_pixel target = map[move->dst.x][move->dst.y];
	map[move->dude->pos.x][move->dude->pos.y] = move->dude->ground;
	move->dude->ground = target;
	target.type = DUDE;
	target.data = move->dude;
}

void resolve_moves(){
	int change = 1;
	int i;
	
	// clear moves
	while(nb_clear > 0){
		i = rand()%nb_clear;
		if(map[clearMoves[i]->dst.x][clearMoves[i]->dst.y].type == DUDE){
			occupiedMoves[nb_occupied++] = clearMoves[i];
		}else{
			applyMove(clearMoves[i]);
		}
		clearMoves[i] = clearMoves[--nb_clear];
	}
	
	// occupied moves
	while(change){
		change = 0;
		for(i=0; i<nb_occupied; i++){
			if(map[occupiedMoves[i]->dst.x][occupiedMoves[i]->dst.y].type != DUDE){
				change = 1;
				applyMove(occupiedMoves[i]);
			}
		}
	}
	nb_occupied = 0;
}

Uint32 getpixel(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;
    switch (bpp) {
    case 1:
        return *p;
    case 2:
        return *(Uint16 *)p;
    case 3:
        if (SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;
    case 4:
        return *(Uint32 *)p;
    default:
        return 0;
    }
}

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
	int bpp = surface->format->BytesPerPixel;
	/* Here p is the address to the pixel we want to set */
	Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;
	switch(bpp) {
	case 1:
		*p = pixel;
		break;
	case 2:
		*(Uint16 *)p = pixel;
		break;
	case 3:
		if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
			p[0] = (pixel >> 16) & 0xff;
			p[1] = (pixel >> 8) & 0xff;
			p[2] = pixel & 0xff;
		} else {
			p[0] = pixel & 0xff;
			p[1] = (pixel >> 8) & 0xff;
			p[2] = (pixel >> 16) & 0xff;
		}
		break;
	case 4:
		*(Uint32 *)p = pixel;
		break;
	}
}